# Answers to the exercises found within the class lecture.

import nltk
from nltk.book import *

#==================================================================================
#%%
'''
Exercise 1:
'''

from nltk.corpus import brown
brown_news_tagged = brown.tagged_words(categories='news', tagset='universal')
tag_fd = nltk.FreqDist(tag for (word, tag) in brown_news_tagged)
tag_fd.most_common()

'''
Plot the above frequency distribution using tag_fd.plot(cumulative=True). 
What percentage of words are tagged using the first five tags of the above list?
'''

tag_fd.plot(cumulative = True)
tag_fd.values()

nums = [num for num in tag_fd.values()]
percent = sum(nums[0:4])/sum(nums) *100
# 62%

#==================================================================================
#%%
'''
Exercise 2:


Import a text file (either your own or the example .txt file provided) using: 

import os
# os.chdir('D:')

f = open('document.txt', 'rU')
raw = f.read()

Now find:
1) The most common tag/ part of speech
2) Look at bigrams to find the most common words and their part of speech that occur before whatever
   the most commor part of speech from #1.
3) Find the most common verbs and sort them by frequency, with the most frequent first.
'''

#==================================================================================
#%%
'''
Exercise 3:
    
Access one of the Shakespeare txt files from gutenberg. You first should display all fileids from gutenberg, how many
Shakespeare files are there?

Now take one of them and create a default dictionary that lables every unknown part of speech as UNK.

Display the first 100 iems in the defaultdict.
'''
# list out all file ids
nltk.corpus.gutenberg.filedids()

# choose one of the 3 Shakespeare files
# 'shakespeare-hamlet.txt'

from collections import defaultdict

shakespeare = nltk.corpus.gutenberg.words('shakespeare-hamlet.txt')
vocab = nltk.FreqDist(shakespeare)
v1000 = [word for (word, _) in vocab.most_common(1000)]

def default_POS():
    return 'UNK'

mapping = defaultdict(default_POS)
for v in v1000:
    mapping[v] = v

shakespeare2 = [mapping[v] for v in shakespeare]
shakespeare2[:100]


#==================================================================================
#%%
'''


Exercise 4:

Using the same Shakespeare text you pulled earlier, build a dictionary that:
	1. Counts the frequency of each part of speech within the text
	2. Sorts the dictionary (using itemgetter) by frequency of part of speech, decreasing in values.
'''

counts = defaultdict(int)
for (word, tag) in nltk.pos_tag(shakespeare):
    counts[tag] += 1

from operator import itemgetter
sorted(counts.items(), key=itemgetter(1), reverse=True)


#==================================================================================
#%%
'''
Exercise 5:

Using the 'words' dictionary, find all words that start with the prefix 'un'.
Store it in a list named unwanted. What is the length of the list?
'''

unwanted = defaultdict(list)
words = nltk.corpus.words.words('en')
for word in words:
    key = word[:2]
    unwanted[key].append(word)

len(unwanted)
#723

#==================================================================================
#%%
'''
Exercise 6:

Explain what the functions above are doing, in plain english. Write each line of each function, but
in pseudo code.
'''

def performance(cfd, wordlist):
    lt = dict((word, cfd[word].max()) for word in wordlist)
    baseline_tagger = nltk.UnigramTagger(model=lt, backoff=nltk.DefaultTagger('NN'))
    return baseline_tagger.evaluate(brown.tagged_sents(categories='news'))

# define a function, performance with two arguments (cfd,wordlist):
    # variable lt = a dictionary with word as the key and max of cfd (arg 1) for each word in the wordlist (arg 2)
    # variable baseline tagger = UnigramTagger model with the dictionary lt and using nltk Default Tagger to default as a noun
    # return the evaluation of the unigram tagger on brown corpus, category news

def display():
    import pylab
    word_freqs = nltk.FreqDist(brown.words(categories='news')).most_common()
    words_by_freq = [w for (w, _) in word_freqs]
    cfd = nltk.ConditionalFreqDist(brown.tagged_words(categories='news'))
    sizes = 2 ** pylab.arange(15)
    perfs = [performance(cfd, words_by_freq[:size]) for size in sizes]
    pylab.plot(sizes, perfs, '-bo')
    pylab.title('Lookup Tagger Performance with Varying Model Size')
    pylab.xlabel('Model Size')
    pylab.ylabel('Performance')
    pylab.show()

# define a function display
    # within display:
        # variable word_freqs = the mostcommon words in brown
        # variable words_by_freq = pull out just the words in word_freqs
        # variable cfd = the frequency of each part of speech for every word in brown
        # variable sizes = set up to use when building the graph
        # perfs = use the function defined above, performance to loop through each number in sizes
        # the base plot using pylab
        # plot title
        # x axis label
        # y axis label
        # show the chart
    

display()
#==================================================================================
#%%
'''
Exercise 7:

Import a text document of your own, use the file open command you learned earlier in the lecture.
Use the function above to tokenize and tag the document. 
'''

    
    
    
    
    
    
    
    
    
    
    